Index: /LMDZ4/trunk/libf/phylmd/thermcell_flux2.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/thermcell_flux2.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/thermcell_flux2.F90	(revision 1403)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
       SUBROUTINE thermcell_flux2(ngrid,klev,ptimestep,masse, &
      &       lalim,lmax,alim_star,  &
@@ -38,5 +41,5 @@
       REAL zfm
 
-      integer igout
+      integer igout,lout
       integer lev_out
       integer lunout1
@@ -46,4 +49,9 @@
       REAL fomass_max,alphamax
       save fomass_max,alphamax
+
+      logical check_debug,labort_gcm
+
+      character (len=20) :: modname='thermcell_flux2'
+      character (len=80) :: abort_message
 
       fomass_max=0.5
@@ -78,6 +86,10 @@
 ! Verification de la nullite des entrainement et detrainement au dessus
 ! de lmax(ig)
-!-------------------------------------------------------------------------
-
+! Active uniquement si check_debug=.true. ou prt_level>=10
+!-------------------------------------------------------------------------
+
+      check_debug=.false..or.prt_level>=10
+
+      if (check_debug) then
       do l=1,klev
          do ig=1,ngrid
@@ -88,5 +100,4 @@
                     print*,'alim_star(ig,l)',alim_star(ig,l)
                     print*,'detr_star(ig,l)',detr_star(ig,l)
-!                   stop
                endif
             else
@@ -96,9 +107,12 @@
                     print*,'alim_star(ig,l)',alim_star(ig,l)
                     print*,'detr_star(ig,l)',detr_star(ig,l)
-                    stop
+                    abort_message = ''
+                    labort_gcm=.true.
+                    CALL abort_gcm (modname,abort_message,1)
                endif
             endif
          enddo
       enddo
+      endif
 
 !-------------------------------------------------------------------------
@@ -253,9 +267,23 @@
 
 !     do l=1,klev
+
+
+
+         labort_gcm=.false.
          do ig=1,ngrid
             if (entr(ig,l)<0.) then
-               print*,'N1 ig,l,entr',ig,l,entr(ig,l)
-               stop 'entr negatif'
-            endif
+               labort_gcm=.true.
+               igout=ig
+               lout=l
+            endif
+         enddo
+
+         if (labort_gcm) then
+            print*,'N1 ig,l,entr',igout,lout,entr(igout,lout)
+            abort_message = 'entr negatif'
+            CALL abort_gcm (modname,abort_message,1)
+         endif
+
+         do ig=1,ngrid
             if (detr(ig,l).gt.fm(ig,l)) then
                ncorecfm6=ncorecfm6+1
@@ -280,12 +308,23 @@
                entr(ig,l)=0.
             endif
-
+         enddo
+
+         labort_gcm=.false.
+         do ig=1,ngrid
             if (entr(ig,l).lt.0.) then
-               print*,'ig,l,lmax(ig)',ig,l,lmax(ig)
-               print*,'entr(ig,l)',entr(ig,l)
-               print*,'fm(ig,l)',fm(ig,l)
-               stop 'probleme dans thermcell flux'
-            endif
-         enddo
+               labort_gcm=.true.
+               igout=ig
+            endif
+         enddo
+         if (labort_gcm) then
+            ig=igout
+            print*,'ig,l,lmax(ig)',ig,l,lmax(ig)
+            print*,'entr(ig,l)',entr(ig,l)
+            print*,'fm(ig,l)',fm(ig,l)
+            abort_message = 'probleme dans thermcell flux'
+            CALL abort_gcm (modname,abort_message,1)
+         endif
+
+
 !     enddo
       endif
@@ -305,14 +344,23 @@
                detr(ig,l)=detr(ig,l)+fm(ig,l+1)
                fm(ig,l+1)=0.
-!              print*,'fm2<0',l+1,lmax(ig)
                ncorecfm2=ncorecfm2+1
             endif
+         enddo
+
+         labort_gcm=.false.
+         do ig=1,ngrid
             if (detr(ig,l).lt.0.) then
+               labort_gcm=.true.
+               igout=ig
+            endif
+        enddo
+        if (labort_gcm) then
+               ig=igout
                print*,'cas 2 : ig,l,lmax(ig)',ig,l,lmax(ig)
                print*,'detr(ig,l)',detr(ig,l)
                print*,'fm(ig,l)',fm(ig,l)
-               stop 'probleme dans thermcell flux'
-            endif
-        enddo
+               abort_message = 'probleme dans thermcell flux'
+               CALL abort_gcm (modname,abort_message,1)
+        endif
 !    enddo
 
@@ -379,4 +427,5 @@
 
       if (1.eq.1) then
+      labort_gcm=.false.
       do l=1,klev-1
          do ig=1,ngrid
@@ -399,4 +448,20 @@
                    else
                       if(l.ge.lmax(ig).and.0.eq.1) then
+                         igout=ig
+                         lout=l
+                         labort_gcm=.true.
+                      endif
+                      entr(ig,l+1)=entr(ig,l+1)-ddd
+                      detr(ig,l)=0.
+                      fm(ig,l+1)=fm(ig,l)+entr(ig,l)
+                      detr(ig,l)=0.
+                   endif
+                endif
+            endif
+         enddo
+      enddo
+      if (labort_gcm) then
+                         ig=igout
+                         l=lout
                          print*,'ig,l',ig,l
                          print*,'eee0',eee0
@@ -413,15 +478,7 @@
                          print*,'fm(ig,l+1)',fm(ig,l+1)
                          print*,'fm(ig,l)',fm(ig,l)
-                         stop 'probleme dans thermcell_flux'
-                      endif
-                      entr(ig,l+1)=entr(ig,l+1)-ddd
-                      detr(ig,l)=0.
-                      fm(ig,l+1)=fm(ig,l)+entr(ig,l)
-                      detr(ig,l)=0.
-                   endif
-                endif
-            endif
-         enddo
-      enddo
+                         abort_message = 'probleme dans thermcell_flux'
+                         CALL abort_gcm (modname,abort_message,1)
+      endif
       endif
 !                  
Index: /LMDZ4/trunk/libf/phylmd/thermcell_height.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/thermcell_height.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/thermcell_height.F90	(revision 1403)
@@ -40,4 +40,14 @@
          enddo
       enddo
+
+! On traite le cas particulier qu'il faudrait éviter ou le thermique
+! atteind le haut du modele ...
+      do ig=1,ngrid
+      if ( zw2(ig,nlay) > 1.e-10 ) then
+          print*,'WARNING !!!!! W2 thermiques non nul derniere couche '
+          lmax(ig)=nlay
+      endif
+      enddo
+
 ! pas de thermique si couche 1 stable
       do ig=1,ngrid
Index: /LMDZ4/trunk/libf/phylmd/thermcell_init.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/thermcell_init.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/thermcell_init.F90	(revision 1403)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
       SUBROUTINE thermcell_init(ngrid,nlay,ztv,zlay,zlev,  &
      &                  lalim,lmin,alim_star,alim_star_tot,lev_out)
@@ -26,137 +29,31 @@
 !def des alim_star tels que alim=f*alim_star      
 
-      do l=1,nlay
-         do ig=1,ngrid 
-            alim_star(ig,l)=0.
-         enddo
-      enddo
-! determination de la longueur de la couche d entrainement
-      do ig=1,ngrid
-         lalim(ig)=1
-      enddo
 
-      if (iflag_thermals_ed.ge.1) then
-!si la première couche est instable, on declenche un thermique
+      write(lunout,*)'THERM INIT V20C '
+
+      alim_star_tot(:)=0.
+      alim_star(:,:)=0.
+      lmin(:)=1
+      lalim(:)=1
+
+      do l=1,nlay-1
          do ig=1,ngrid
-            if (ztv(ig,1).gt.ztv(ig,2)) then
-               lmin(ig)=1
-               lalim(ig)=2
-               alim_star(ig,1)=1.
-               alim_star_tot(ig)=alim_star(ig,1)
-               if(prt_level.GE.10) print*,'init',alim_star(ig,1),alim_star_tot(ig)
-            else
-                lmin(ig)=1
-                lalim(ig)=1
-                alim_star(ig,1)=0.
-                alim_star_tot(ig)=0. 
-            endif
-         enddo
- 
-         else
-!else iflag_thermals_ed=0 ancienne def de l alim 
-
-!on ne considere que les premieres couches instables
-      do l=nlay-2,1,-1
-         do ig=1,ngrid
-            if (ztv(ig,l).gt.ztv(ig,l+1).and.  &
-     &          ztv(ig,l+1).le.ztv(ig,l+2)) then
-               lalim(ig)=l+1
-            endif
-          enddo
-      enddo
-
-! determination du lmin: couche d ou provient le thermique
-
-      do ig=1,ngrid
-! FH initialisation de lmin a nlay plutot que 1.
-!        lmin(ig)=nlay
-         lmin(ig)=1
-      enddo
-      do l=nlay,2,-1
-         do ig=1,ngrid
-            if (ztv(ig,l-1).gt.ztv(ig,l)) then
-               lmin(ig)=l-1
+            if (ztv(ig,l)> ztv(ig,l+1) .and. ztv(ig,1)>=ztv(ig,l) ) then
+               alim_star(ig,l)=MAX((ztv(ig,l)-ztv(ig,l+1)),0.)  &
+     &                       *sqrt(zlev(ig,l+1)) 
+               lalim(:)=l+1
+               alim_star_tot(ig)=alim_star_tot(ig)+alim_star(ig,l)
             endif
          enddo
       enddo
-!
-      zzalim(:)=0.
-      do l=1,nlay-1
+      do l=1,nlay
          do ig=1,ngrid 
-             if (l<lalim(ig)) then
-                zzalim(ig)=zzalim(ig)+zlay(ig,l)*(ztv(ig,l)-ztv(ig,l+1))
-             endif
-          enddo
-      enddo
-      do ig=1,ngrid
-          if (lalim(ig)>1) then
-             zzalim(ig)=zlay(ig,1)+zzalim(ig)/(ztv(ig,1)-ztv(ig,lalim(ig)))
-          else
-             zzalim(ig)=zlay(ig,1)
-          endif
-      enddo
-
-      if(prt_level.GE.10) print*,'ZZALIM LALIM ',zzalim,lalim,zlay(1,lalim(1))
-
-! definition de l'entrainement des couches
-      if (1.eq.1) then
-      do l=1,nlay-1
-         do ig=1,ngrid 
-            if (ztv(ig,l).gt.ztv(ig,l+1).and.  &
-     &          l.ge.lmin(ig).and.l.lt.lalim(ig)) then
-!def possibles pour alim_star: zdthetadz, dthetadz, zdtheta
-             alim_star(ig,l)=MAX((ztv(ig,l)-ztv(ig,l+1)),0.)  &
-     &                       *sqrt(zlev(ig,l+1)) 
-            endif
-         enddo
-      enddo
-      else
-      do l=1,nlay-1
-         do ig=1,ngrid
-            if (ztv(ig,l).gt.ztv(ig,l+1).and.  &
-     &          l.ge.lmin(ig).and.l.lt.lalim(ig)) then
-             alim_star(ig,l)=max(3.*zzalim(ig)-zlay(ig,l),0.) &
-     &        *(zlev(ig,l+1)-zlev(ig,l))
-            endif
-         enddo
-      enddo
-      endif
-      
-! pas de thermique si couche 1 stable
-      do ig=1,ngrid
-!CRnouveau test
-        if (alim_star(ig,1).lt.1.e-10) then 
-            do l=1,nlay
-                alim_star(ig,l)=0.
-            enddo
-            lmin(ig)=1
-         endif
-      enddo 
-! calcul de l alimentation totale
-      do ig=1,ngrid
-         alim_star_tot(ig)=0.
-      enddo
-      do l=1,nlay
-         do ig=1,ngrid
-            alim_star_tot(ig)=alim_star_tot(ig)+alim_star(ig,l)
-         enddo
-      enddo
-!
-! Calcul entrainement normalise
-      do l=1,nlay 
-         do ig=1,ngrid 
-            if (alim_star_tot(ig).gt.1.e-10) then
+            if (alim_star_tot(ig) > 1.e-10 ) then
                alim_star(ig,l)=alim_star(ig,l)/alim_star_tot(ig)
             endif
          enddo
       enddo
-       
-!on remet alim_star_tot a 1
-      do ig=1,ngrid 
-         alim_star_tot(ig)=1.
-      enddo
+      alim_star_tot(:)=1.
 
-      endif
-!endif iflag_thermals_ed
-      return 
+      return
       end  
Index: /LMDZ4/trunk/libf/phylmd/thermcell_main.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/thermcell_main.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/thermcell_main.F90	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE thermcell_main(itap,ngrid,nlay,ptimestep  &
@@ -8,7 +8,8 @@
      &                  ,fm0,entr0,detr0,zqta,zqla,lmax  &
      &                  ,ratqscth,ratqsdiff,zqsatth  &
-     &                  ,r_aspect,l_mix,tau_thermals &
+     &                  ,r_aspect,l_mix,tau_thermals,iflag_thermals_ed &
      &                  ,Ale_bl,Alp_bl,lalim_conv,wght_th &
-     &                  ,zmax0, f0,zw2,fraca)
+     &                  ,zmax0, f0,zw2,fraca,ztv &
+     &                  ,zpspsk,ztla,zthl)
 
       USE dimphy
@@ -22,11 +23,11 @@
 !   de "thermiques" explicitement representes avec processus nuageux
 !
-!   Réécriture à partir d'un listing papier à Habas, le 14/02/00
-!
-!   le thermique est supposé homogène et dissipé par mélange avec
-!   son environnement. la longueur l_mix contrôle l'efficacité du
-!   mélange
-!
-!   Le calcul du transport des différentes espèces se fait en prenant
+!   Reecriture a partir d'un listing papier a Habas, le 14/02/00
+!
+!   le thermique est suppose homogene et dissipe par melange avec
+!   son environnement. la longueur l_mix controle l'efficacite du
+!   melange
+!
+!   Le calcul du transport des differentes especes se fait en prenant
 !   en compte:
 !     1. un flux de masse montant
@@ -55,4 +56,5 @@
       INTEGER ngrid,nlay,w2di
       real tau_thermals
+      integer iflag_thermals_ed
       real ptimestep,l_mix,r_aspect
       REAL pt(ngrid,nlay),pdtadj(ngrid,nlay)
@@ -85,5 +87,5 @@
       real linter(klon)
       real zmix(klon)
-      real zmax(klon),zw2(klon,klev+1),ztva(klon,klev),zw_est(klon,klev+1)
+      real zmax(klon),zw2(klon,klev+1),ztva(klon,klev),zw_est(klon,klev+1),ztva_est(klon,klev)
 !      real fraca(klon,klev)
 
@@ -115,4 +117,7 @@
 ! FH probleme de dimensionnement avec l'allocation dynamique
 !     common/comtherm/thetath2,wth2
+      real wq(klon,klev)
+      real wthl(klon,klev)
+      real wthv(klon,klev)
     
       real ratqscth(klon,klev)
@@ -126,4 +131,5 @@
 
       real wmax(klon)
+      real wmax_tmp(klon)
       real wmax_sec(klon)
       real fm0(klon,klev+1),entr0(klon,klev),detr0(klon,klev)
@@ -142,6 +148,7 @@
       real f_star(klon,klev+1),entr_star(klon,klev)
       real detr_star(klon,klev)
-      real alim_star_tot(klon),alim_star2(klon)
+      real alim_star_tot(klon)
       real alim_star(klon,klev)
+      real alim_star_clos(klon,klev)
       real f(klon), f0(klon)
 !FH/IM     save f0
@@ -149,4 +156,5 @@
       logical debut
        real seuil
+      real csc(klon,klev)
 
 !
@@ -166,4 +174,7 @@
       character*10 str10
 
+      character (len=20) :: modname='thermcell_main'
+      character (len=80) :: abort_message
+
       EXTERNAL SCOPY
 !
@@ -182,5 +193,4 @@
 
 
-! #define wrgrads_thermcell
 #undef wrgrads_thermcell
 #ifdef wrgrads_thermcell
@@ -200,4 +210,5 @@
       fm=0. ; entr=0. ; detr=0.
 
+
       icount=icount+1
 
@@ -220,18 +231,5 @@
       ENDIF
 !
-!Initialisation
-!
-!    IF (1.eq.0) THEN
-!     do ig=1,klon      
-!FH/IM 130308     if ((debut).or.((.not.debut).and.(f0(ig).lt.1.e-10))) then
-!     if ((.not.debut).and.(f0(ig).lt.1.e-10)) then
-!           f0(ig)=1.e-5
-!           zmax0(ig)=40.
-!v1d        therm=.false.
-!     endif
-!     enddo 
-!    ENDIF !(1.eq.0) THEN
-     if (prt_level.ge.10)write(lunout,*)                                &
-    &     'WARNING thermcell_main f0=max(f0,1.e-2)'
+!     write(lunout,*)'WARNING thermcell_main f0=max(f0,1.e-2)'
      do ig=1,klon
       if (prt_level.ge.20) then
@@ -239,4 +237,5 @@
       endif
          f0(ig)=max(f0(ig),1.e-2)
+         zmax0(ig)=max(zmax0(ig),40.)
 !IMmarche pas ?!       if (f0(ig)<1.e-2) f0(ig)=1.e-2
      enddo
@@ -364,41 +363,93 @@
 
 !------------------------------------------------------------------
-!  1. alim_star est le profil vertical de l'alimentation à la base du
-!     panache thermique, calculé à partir de la flotabilité de l'air sec
+!  1. alim_star est le profil vertical de l'alimentation a la base du
+!     panache thermique, calcule a partir de la flotabilite de l'air sec
 !  2. lmin et lalim sont les indices inferieurs et superieurs de alim_star
 !------------------------------------------------------------------
 !
       entr_star=0. ; detr_star=0. ; alim_star=0. ; alim_star_tot=0.
-      CALL thermcell_init(ngrid,nlay,ztv,zlay,zlev,  &
-     &                    lalim,lmin,alim_star,alim_star_tot,lev_out)
-
-call test_ltherm(ngrid,nlay,pplev,pplay,lmin,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_init lmin  ')
-call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_init lalim ')
-
-
-      if (prt_level.ge.1) print*,'thermcell_main apres thermcell_init'
-      if (prt_level.ge.10) then
-         write(lunout1,*) 'Dans thermcell_main 1'
-         write(lunout1,*) 'lmin ',lmin(igout)
-         write(lunout1,*) 'lalim ',lalim(igout)
-         write(lunout1,*) ' ig l alim_star thetav'
-         write(lunout1,'(i6,i4,2e15.5)') (igout,l,alim_star(igout,l) &
-     &   ,ztv(igout,l),l=1,lalim(igout)+4)
-      endif
-
-!v1d      do ig=1,klon
-!v1d     if (alim_star(ig,1).gt.1.e-10) then
-!v1d     therm=.true.
-!v1d     endif
-!v1d      enddo
+      lmin=1
+
 !-----------------------------------------------------------------------------
 !  3. wmax_sec et zmax_sec sont les vitesses et altitudes maximum d'un
 !     panache sec conservatif (e=d=0) alimente selon alim_star 
 !     Il s'agit d'un calcul de type CAPE
-!     zmax_sec est utilisé pour déterminer la géométrie du thermique.
+!     zmax_sec est utilise pour determiner la geometrie du thermique.
 !------------------------------------------------------------------------------
-!
+!---------------------------------------------------------------------------------
+!calcul du melange et des variables dans le thermique
+!--------------------------------------------------------------------------------
+!
+      if (prt_level.ge.1) print*,'avant thermcell_plume ',lev_out
+!IM 140508   CALL thermcell_plume(ngrid,nlay,ptimestep,ztv,zthl,po,zl,rhobarz,  &
+
+! Gestion temporaire de plusieurs appels à thermcell_plume au travers
+! de la variable iflag_thermals
+
+!      print*,'THERM thermcell_main iflag_thermals_ed=',iflag_thermals_ed
+      if (iflag_thermals_ed<=9) then
+!         print*,'THERM NOUVELLE/NOUVELLE Arnaud'
+         CALL thermcell_plume(itap,ngrid,nlay,ptimestep,ztv,zthl,po,zl,rhobarz,&
+     &    zlev,pplev,pphi,zpspsk,alim_star,alim_star_tot,  &
+     &    lalim,f0,detr_star,entr_star,f_star,csc,ztva,  &
+     &    ztla,zqla,zqta,zha,zw2,zw_est,ztva_est,zqsatth,lmix,lmix_bis,linter &
+     &    ,lev_out,lunout1,igout)
+
+      elseif (iflag_thermals_ed>9) then
+!        print*,'THERM RIO et al 2010, version d Arnaud'
+         CALL thermcellV1_plume(itap,ngrid,nlay,ptimestep,ztv,zthl,po,zl,rhobarz,&
+     &    zlev,pplev,pphi,zpspsk,alim_star,alim_star_tot,  &
+     &    lalim,f0,detr_star,entr_star,f_star,csc,ztva,  &
+     &    ztla,zqla,zqta,zha,zw2,zw_est,ztva_est,zqsatth,lmix,lmix_bis,linter &
+     &    ,lev_out,lunout1,igout)
+
+      endif
+
+      if (prt_level.ge.1) print*,'apres thermcell_plume ',lev_out
+
+      call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lalim ')
+      call test_ltherm(ngrid,nlay,pplev,pplay,lmix ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lmix  ')
+
+      if (prt_level.ge.1) print*,'thermcell_main apres thermcell_plume'
+      if (prt_level.ge.10) then
+         write(lunout1,*) 'Dans thermcell_main 2'
+         write(lunout1,*) 'lmin ',lmin(igout)
+         write(lunout1,*) 'lalim ',lalim(igout)
+         write(lunout1,*) ' ig l alim_star entr_star detr_star f_star '
+         write(lunout1,'(i6,i4,4e15.5)') (igout,l,alim_star(igout,l),entr_star(igout,l),detr_star(igout,l) &
+     &    ,f_star(igout,l+1),l=1,nint(linter(igout))+5)
+      endif
+
+!-------------------------------------------------------------------------------
+! Calcul des caracteristiques du thermique:zmax,zmix,wmax
+!-------------------------------------------------------------------------------
+!
+      CALL thermcell_height(ngrid,nlay,lalim,lmin,linter,lmix,zw2,  &
+     &           zlev,lmax,zmax,zmax0,zmix,wmax,lev_out)
+! Attention, w2 est transforme en sa racine carree dans cette routine
+! Le probleme vient du fait que linter et lmix sont souvent égaux à 1.
+      wmax_tmp=0.
+      do  l=1,nlay
+         wmax_tmp(:)=max(wmax_tmp(:),zw2(:,l))
+      enddo
+!     print*,"ZMAX ",lalim,lmin,linter,lmix,lmax,zmax,zmax0,zmix,wmax
+
+
+
+      call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lalim ')
+      call test_ltherm(ngrid,nlay,pplev,pplay,lmin ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmin  ')
+      call test_ltherm(ngrid,nlay,pplev,pplay,lmix ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmix  ')
+      call test_ltherm(ngrid,nlay,pplev,pplay,lmax ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmax  ')
+
+      if (prt_level.ge.1) print*,'thermcell_main apres thermcell_height'
+
+!-------------------------------------------------------------------------------
+! Fermeture,determination de f
+!-------------------------------------------------------------------------------
+!
+!
+!!      write(lunout,*)'THERM NOUVEAU XXXXX'
       CALL thermcell_dry(ngrid,nlay,zlev,pphi,ztv,alim_star,  &
-     &                      lalim,lmin,zmax_sec,wmax_sec,lev_out)
+    &                      lalim,lmin,zmax_sec,wmax_sec,lev_out)
 
 call test_ltherm(ngrid,nlay,pplev,pplay,lmin,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_dry  lmin  ')
@@ -417,59 +468,20 @@
 
 
-!---------------------------------------------------------------------------------
-!calcul du melange et des variables dans le thermique
-!--------------------------------------------------------------------------------
-!
-      if (prt_level.ge.1) print*,'avant thermcell_plume ',lev_out
-!IM 140508   CALL thermcell_plume(ngrid,nlay,ptimestep,ztv,zthl,po,zl,rhobarz,  &
-      CALL thermcell_plume(itap,ngrid,nlay,ptimestep,ztv,zthl,po,zl,rhobarz,  &
-     &           zlev,pplev,pphi,zpspsk,l_mix,r_aspect,alim_star,alim_star_tot,  &
-     &           lalim,zmax_sec,f0,detr_star,entr_star,f_star,ztva,  &
-     &           ztla,zqla,zqta,zha,zw2,zw_est,zqsatth,lmix,lmix_bis,linter &
-     &            ,lev_out,lunout1,igout)
-      if (prt_level.ge.1) print*,'apres thermcell_plume ',lev_out
-
-      call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lalim ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmix ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_plum lmix  ')
-
-      if (prt_level.ge.1) print*,'thermcell_main apres thermcell_plume'
-      if (prt_level.ge.10) then
-         write(lunout1,*) 'Dans thermcell_main 2'
-         write(lunout1,*) 'lmin ',lmin(igout)
-         write(lunout1,*) 'lalim ',lalim(igout)
-         write(lunout1,*) ' ig l alim_star entr_star detr_star f_star '
-         write(lunout1,'(i6,i4,4e15.5)') (igout,l,alim_star(igout,l),entr_star(igout,l),detr_star(igout,l) &
-     &    ,f_star(igout,l+1),l=1,nint(linter(igout))+5)
-      endif
-
-!-------------------------------------------------------------------------------
-! Calcul des caracteristiques du thermique:zmax,zmix,wmax
-!-------------------------------------------------------------------------------
-!
-      CALL thermcell_height(ngrid,nlay,lalim,lmin,linter,lmix,zw2,  &
-     &           zlev,lmax,zmax,zmax0,zmix,wmax,lev_out)
-
-
-      call test_ltherm(ngrid,nlay,pplev,pplay,lalim,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lalim ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmin ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmin  ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmix ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmix  ')
-      call test_ltherm(ngrid,nlay,pplev,pplay,lmax ,seuil,ztv,po,ztva,zqla,f_star,zw2,'thermcell_heig lmax  ')
-
-      if (prt_level.ge.1) print*,'thermcell_main apres thermcell_height'
-
-!-------------------------------------------------------------------------------
-! Fermeture,determination de f
-!-------------------------------------------------------------------------------
-!
-!avant closure: on redéfinit lalim, alim_star_tot et alim_star
-!       do ig=1,klon
-!       do l=2,lalim(ig)
-!       alim_star(ig,l)=entr_star(ig,l)
-!       entr_star(ig,l)=0.
-!       enddo
-!       enddo
-
+
+! Choix de la fonction d'alimentation utilisee pour la fermeture.
+! Apparemment sans importance
+      alim_star_clos(:,:)=alim_star(:,:)
+      alim_star_clos(:,:)=entr_star(:,:)+alim_star(:,:)
+
+! Appel avec la version seche
       CALL thermcell_closure(ngrid,nlay,r_aspect,ptimestep,rho,  &
-     &   zlev,lalim,alim_star,alim_star_tot,zmax_sec,wmax_sec,zmax,wmax,f,lev_out)
+     &   zlev,lalim,alim_star_clos,f_star,zmax_sec,wmax_sec,f,lev_out)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Appel avec les zmax et wmax tenant compte de la condensation
+! Semble moins bien marcher
+!     CALL thermcell_closure(ngrid,nlay,r_aspect,ptimestep,rho,  &
+!    &   zlev,lalim,alim_star,f_star,zmax,wmax,f,lev_out)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
       if(prt_level.ge.1)print*,'thermcell_closure apres thermcell_closure'
@@ -484,5 +496,6 @@
 ! Test valable seulement en 1D mais pas genant
       if (.not. (f0(1).ge.0.) ) then
-           stop 'Dans thermcell_main'
+              abort_message = '.not. (f0(1).ge.0.)'
+              CALL abort_gcm (modname,abort_message,1)
       endif
 
@@ -511,5 +524,5 @@
          fm0=(1.-lambda)*fm+lambda*fm0
          entr0=(1.-lambda)*entr+lambda*entr0
-!        detr0=(1.-lambda)*detr+lambda*detr0
+         detr0=(1.-lambda)*detr+lambda*detr0
       else
          fm0=fm
@@ -560,5 +573,5 @@
      &    ,fraca,zmax  &
      &    ,zu,zv,pduadj,pdvadj,zua,zva,lev_out)
-!IM 050508    &    ,zu,zv,pduadj,pdvadj,zua,zva,igout,lev_out)
+
       else
 
@@ -596,5 +609,6 @@
       pcon(ig)=pplay(ig,1)*(zo(ig,1)/zqsat(ig,1))**CHI
       enddo
-      do k=1,nlay
+!IM   do k=1,nlay
+      do k=1,nlay-1
          do ig=1,ngrid
          if ((pcon(ig).le.pplay(ig,k))  &
@@ -603,4 +617,12 @@
          endif
          enddo
+      enddo
+!IM
+      do ig=1,ngrid
+        if (pcon(ig).le.pplay(ig,nlay)) then 
+           zcon2(ig)=zlay(ig,nlay)-(pcon(ig)-pplay(ig,nlay))/(RG*rho(ig,nlay))/100.
+           abort_message = 'thermcellV0_main: les thermiques vont trop haut '
+           CALL abort_gcm (modname,abort_message,1)
+        endif
       enddo
       if (prt_level.ge.1) print*,'14b OK convect8'
@@ -636,5 +658,5 @@
 !
       if (prt_level.ge.10) print*,'14f OK convect8 ig,l,zha zh zpspsk ',ig,l,zha(ig,l),zh(ig,l),zpspsk(ig,l)
-            thetath2(ig,l)=zf2*(zha(ig,l)-zh(ig,l)/zpspsk(ig,l))**2
+            thetath2(ig,l)=zf2*(ztla(ig,l)-zthl(ig,l))**2
             if(zw2(ig,l).gt.1.e-10) then
              wth2(ig,l)=zf2*(zw2(ig,l))**2
@@ -651,56 +673,33 @@
          enddo
       enddo
-!calcul de ale_bl et alp_bl
-!pour le calcul d'une valeur intégrée entre la surface et lmax
-      do ig=1,ngrid
-      alp_int(ig)=0.
-      ale_int(ig)=0.
-      n_int(ig)=0
-      enddo
-!
-      do l=1,nlay
-      do ig=1,ngrid
-       if(l.LE.lmax(ig)) THEN
-        alp_int(ig)=alp_int(ig)+0.5*rhobarz(ig,l)*wth3(ig,l)
-        ale_int(ig)=ale_int(ig)+0.5*zw2(ig,l)**2
-        n_int(ig)=n_int(ig)+1
-       endif
-      enddo
-      enddo
+!calcul des flux: q, thetal et thetav
+      do l=1,nlay
+         do ig=1,ngrid
+      wq(ig,l)=fraca(ig,l)*zw2(ig,l)*(zqta(ig,l)*1000.-po(ig,l)*1000.)
+      wthl(ig,l)=fraca(ig,l)*zw2(ig,l)*(ztla(ig,l)-zthl(ig,l))
+      wthv(ig,l)=fraca(ig,l)*zw2(ig,l)*(ztva(ig,l)-ztv(ig,l))
+         enddo
+      enddo
+!
 !      print*,'avant calcul ale et alp' 
 !calcul de ALE et ALP pour la convection
-      do ig=1,ngrid
-!      Alp_bl(ig)=0.5*rhobarz(ig,lmix_bis(ig))*wth3(ig,lmix(ig))
-!          Alp_bl(ig)=0.5*rhobarz(ig,nivcon(ig))*wth3(ig,nivcon(ig))
-!      Alp_bl(ig)=0.5*rhobarz(ig,lmix(ig))*wth3(ig,lmix(ig)) 
-!     &           *0.1
-!valeur integree de alp_bl * 0.5:
-       if (n_int(ig).gt.0) then
-       Alp_bl(ig)=0.5*alp_int(ig)/n_int(ig)
-!       if (Alp_bl(ig).lt.0.) then
-!       Alp_bl(ig)=0.
-       endif
-!       endif
-!         write(18,*),'rhobarz,wth3,Alp',rhobarz(ig,nivcon(ig)),
-!     s               wth3(ig,nivcon(ig)),Alp_bl(ig)
-!            write(18,*),'ALP_BL',Alp_bl(ig),lmix(ig)
-!      Ale_bl(ig)=0.5*zw2(ig,lmix_bis(ig))**2
-!      if (nivcon(ig).eq.1) then
-!       Ale_bl(ig)=0.
-!       else
-!valeur max de ale_bl:
-       Ale_bl(ig)=0.5*zw2(ig,lmix(ig))**2 
-!     & /2.
-!     & *0.1
-!        Ale_bl(ig)=0.5*zw2(ig,lmix_bis(ig))**2 
-!       if (n_int(ig).gt.0) then
-!       Ale_bl(ig)=ale_int(ig)/n_int(ig)
-!        Ale_bl(ig)=4.
-!       endif
-!       endif
-!            Ale_bl(ig)=0.5*wth2(ig,lmix_bis(ig))
-!          Ale_bl(ig)=wth2(ig,nivcon(ig))
-!          write(19,*),'wth2,ALE_BL',wth2(ig,nivcon(ig)),Ale_bl(ig)
-      enddo
+      Alp_bl(:)=0.
+      Ale_bl(:)=0.
+!          print*,'ALE,ALP ,l,zw2(ig,l),Ale_bl(ig),Alp_bl(ig)'
+      do l=1,nlay
+      do ig=1,ngrid
+           Alp_bl(ig)=max(Alp_bl(ig),0.5*rhobarz(ig,l)*wth3(ig,l) )
+           Ale_bl(ig)=max(Ale_bl(ig),0.5*zw2(ig,l)**2)
+!          print*,'ALE,ALP',l,zw2(ig,l),Ale_bl(ig),Alp_bl(ig)
+      enddo
+      enddo
+
+!     print*,'AAAAAAA ',Alp_bl,Ale_bl,lmix
+
+
+! TEST. IL FAUT REECRIRE LES ALE et ALP
+!     Ale_bl(:)=0.5*wmax(:)*wmax(:)
+!     Alp_bl(:)=0.1*wmax(:)*wmax(:)*wmax(:)
+
 !test:calcul de la ponderation des couches pour KE
 !initialisations
@@ -782,6 +781,6 @@
 !     print*,'15 OK convect8'
 
+#ifdef wrgrads_thermcell
       if (prt_level.ge.1) print*,'thermcell_main sorties 3D'
-#ifdef wrgrads_thermcell
 #include "thermcell_out3d.h"
 #endif
@@ -791,5 +790,4 @@
       if (prt_level.ge.1) print*,'thermcell_main FIN  OK'
 
-!     if(icount.eq.501) stop'au pas 301 dans thermcell_main'
       return
       end
@@ -827,5 +825,4 @@
                   write(6,'(i3,7f10.3)') k,pplay(i,k),ztv(i,k),1000*po(i,k),ztva(i,k),1000*zqla(i,k),f_star(i,k),zw2(i,k)
                enddo
-!              stop
            endif
          enddo
